-- made by jos_balcaen@hotmail.com
/*
log...

v03 on 28/11/2011
		delete turbosmooth option added
v03.2 
		import option
	on 26/12/2011
		changed to tab UI
		render multiple files removed. just import/export
		selection in list possible for importing and exporting. possible to remove items out of list
	on 22/02/2012
		import and export options only for first one (not every object in selection)
		move objects to [0,0,0]  (user request by TheBat on scriptspot)
v03.3
		export multiple maxfiles also as non seperate objects
	on 29/03/2012
		seems I was confused last time. checkbox worked the opposite way.fixed now
	on 30/03/2012
		added option to export as .max (user request by sedus69 on scriptspot)
	on 13/04/201
		solved export fbx bug
v03.4
	on20/11/2012
		export objects with a given prefix together. UCX_ for udk for example (user request by Edward Duke-Cox)
		
TODO
	- Add support for groups
*/

macroScript Jos_Batch_Exporter_Renderer
category:"Custom"
tooltip:"Export/render multiple objects/files v03.4"
buttontext:"IMP/EXP"

(
	
	function ResetObjects	= () --predeclaration
	function DeleteTurbo = () 

	global Tabs 
	try(destroyDialog Tabs)catch()
	
	local LastSubRollout = 1
	local roll_import, roll_export

	rollout roll_Total "BATCH EXPORTER/RENDER v03.2"
	(
	
		SubRollout subroll_resetobj "Reset object"
		--SubRollout subroll_info "bla"
		local OutputTextFile = ""
		
	)
	rollout roll_export "Export Settings"
	(
		--label lbltitle "BATCH EXPORT - selection"
		
		checkbox cbxResetObj offset:[-5,0] tooltip:"reset geometry when exporting \n(will be undone after export)" across:3
		button btnReset "Now" width:50 tooltip:"reset geometry now" offset:[-80,0]
		label lblInfo "Reset geometry" offset:[-80,0] align:#left
		checkbox cbxDeleteTurbo offset:[-5,0] tooltip:"delete turbosmooth modifiers on selected objects when exporting \n(will be undone after export)" across:3
		button btnDeleteTurbo "Now" width:50 tooltip:"delete turbosmooth modifiers on selected objects" offset:[-80,0]
		label lblInfo2 "Delete turbosmooth" offset:[-80,0] align:#left
		checkbox cbxMoveToOrigin across:3 offset:[-5,0]
		button btnMoveToOrigin "Now" width:50 offset:[-80,0]
		label lblMoveToOrigin "Move objects to [0,0,0]" offset:[-80,0] align:#left
		--label lblOutput "Output" pos:[10,60]
		--edittext edtOutputpath pos:[10,90] width:200 height:20 text:(getDir #export) 
		label lbl "" height:1
		Group "Output"
		(
			dropdownlist ddlOutputpath width:210 height:20 items:#(GetDir #export) tooltip:"" across:2
			button btnGetMap "..." width:25 height:20 tooltip:"Browse for folder" offset:[50,0]
			label lblformat "format" across:2 align:#left
			dropdownlist ddlFormat items:#("obj","fbx","3ds","max","ase","dwf","dwg","dxf","dae") selection:1 width:50 align:#left offset:[-80,0]
			checkbox cbxChangeName tooltip:"change exportname, example:\nhouse_+scene name+_v2" across:2
			label lblChangeName "Enable name change" align:#left offset:[-90,0]
			edittext edtPrefix width:75 height:20 across:3
			label lblObjectName "+ obj name +"
			edittext edtSuffix width:75 height:20
		)
		checkbox cbxseparate pos:[5,215] checked:true
		label lblseparate "Separate objects" pos:[30,215]
		checkbox cbxUdk pos:[5,235] checked:true tooltip:"objects with name x and prefix_x in selection will be export together"
		label lblUdk "Export collisions, prefix " pos:[30,235]
		edittext edtUdk pos:[150,235] width:50 text:"UCX_"
		checkbox cbxExportOptions pos:[5,255] tooltip:"Display export dialog"
		label lblExportOptions "Export options" pos:[30,255]
		button btnExport "Export selection" pos:[5,275] width:250 height:25
		
		--if IsOutputTextFile == false do messagebox "undefined" --do --(OutputArr = #(getDir #export))
			
	--	local IsOutputTextFile = false
		----------------------------------------------------
		local OuputArr = #()
		on roll_export open do
		(
			try
			(
				--roll_multi
				-- we proberen een txt file aan te maken in de onderstaande folder als deze nog niet bestaat. als dit niet lukt is er niets aan de hand
				dir = "c:\3dsmax\MAXScript\JosBalcaen_Batch_Exporter"
				makeDir  dir
				OutputTextFile = dir + "/OutputPath.txt"
				filestreamvar = openFile OutputTextFile mode:"r+"
				if  filestreamvar == undefined do 
				(
					createFile OutputTextFile
					filestreamvar = openFile OutputTextFile
					--if  filestreamvar == undefined do messagebox "Can't find OutputPath.txt"
				)
				if filestreamvar != undefined do
				(
					--print "read textfile"
					IsOutputTextFile = true
					i=1
					while not eof filestreamvar do
					(
						inputData = readLine filestreamvar
						if inputData !=undefined do
						(
							OuputArr[i] = inputData
							i = i+ 1
						)
					)
					ddlOutputpath.items = OuputArr
					close filestreamvar
				)
				-- bij het openen tooltip van ddlOutputpath aanpassen want je kan het volledige pad nie lezen
				ddlOutputpath.tooltip = OuputArr[1] as string
			)
			catch()
		)
		----------------------------------------------------
		
			on btnReset pressed do
			(
				if $ != undefined then
				(
					SelectionList = getCurrentSelection()
					ResetObjects SelectionList 0
				)
				else messagebox "Need a selected obj"
			)
			on btnDeleteTurbo pressed do
			(
				if $ != undefined then
				(
					SelectionList = getCurrentSelection()
					DeleteTurbo SelectionList 0
				)
				else messagebox "Need a selected obj"
			)
			on btnMoveToOrigin pressed do
			(
				for i in selection do
				(
					i.pos = [0,0,0]
				)
			)
			on btnGetMap pressed do
			(
				OutputArr = ddlOutputpath.items
				newArr = #()
				for i = 1 to OutputArr.count do
				(
					item = OutputArr[i]
					newArr[i+1] = item
				)
				OutputArr = newArr
				OutputArr[1] = getSavePath "Save to:" initialDir:"C:\Users\Jos\Desktop" as string--getOpenFileName() --(getDir #maxroot)
				ddlOutputpath.items = OutputArr
				--tooltip aanpassen van ddlOutputpath want je kan het soms niet helemaal lezen
				ddlOutputpath.selection = 1
				ddlOutputpath.tooltip = ddlOutputpath.items[1] as string
			)
			on ddlOutputpath selected arg do
			(
				ddlOutputpath.tooltip = OuputArr[arg] as string
			)	
			on btnExport pressed do
			(
					SelectionList = getCurrentSelection()
					newselection = #()
					Extention = ddlFormat.items[ddlFormat.selection]
					OuputArr = ddlOutputpath.items
					OutputPath = OuputArr[ddlOutputpath.selection]
					for i=1 to SelectionList.count do
					(
						--if export collisions is first check if node has the prefix if it has dont export this node because it will be exported together with the original node
						if cbxUdk.checked do
						(
							n = SelectionList[i].name
							prefix = edtUdk.text
							check = findString n prefix
							print n
							print check
							if check != undefined do continue
						)
						
						if cbxChangeName.checked == true then
						(
							Filename = OutputPath + "\\" + edtPrefix.text + SelectionList[i].name + edtSuffix.text + "." + Extention
						)
						else Filename = OutputPath + "\\" + SelectionList[i].name + "." + Extention
						if cbxDeleteTurbo.checked == true or cbxResetObj.checked == true or cbxMoveToOrigin.checked == true do
						(
							undo on
							(
								if cbxDeleteTurbo.checked == true do 
								(
									for m in SelectionList[i].modifiers do
									(
										if classOf m==turboSmooth do deleteModifier SelectionList[i] m
									)
								)--DeleteTurbo SelectionList i
								if cbxResetObj.checked == true do ( SelectionList[i] = ResetObjects SelectionList i)
								if cbxMoveToOrigin.checked == true do
								(
									for i = 1 to SelectionList.count do
									(
										SelectionList[i].pos = [0,0,0]
									)
								)
							)
						)
						
						if ( cbxResetObj.checked == false ) do select SelectionList[i] -- need select the current obj to export seperatly
						--check if we have to export a collision object
						if cbxUdk.checked do
						(
							n = $.name
							obj = $
							c = edtUdk.text+n as string
							c = getNodeByName c exact:true ignoreCase:true all:false 
							if c != undefined do 
							(
								print "select them both"
								print obj
								print c
								select #(obj,c)
							)
						)
						if cbxExportOptions.checked then
						(
							if cbxseparate.checked then
							(
								
								if Extention == "max" then
								(
									--print "maxfile"
									test = saveNodes $ Filename quiet:false 
								)
								else
								(
									exportfile Filename selectedOnly:TRUE
								)
							)
							else
							(
								exportfile Filename 
							)
							cbxExportOptions.checked = false
						)
						else --without options
						(
							if cbxseparate.checked then
							(
								if Extention == "max" then
								(
									test = saveNodes $ Filename quiet:false 
								)
								else
								(
									--messageBox "export"
									exportfile Filename #noPrompt selectedOnly:TRUE 
								)
							)
							else
							(
								exportfile Filename #noPrompt 
							)
						)
						if cbxDeleteTurbo.checked or cbxResetObj.checked or cbxMoveToOrigin.checked do max undo -- undo geo reset
						
						--append newselection SelectionList[i]
					)
					--select newselection
					message = "Objects in selection were succesfull exported to the folder : " +  OutputPath
					messagebox message title:"Batch Export" beep:false

			)
			-- als rollout gesloten wordt willen we de outputpaden naar de txt file schrijven.
			-- als de array van de outputpaden groter is dan 5 verwijderen we de laatse zodat er maar 5 overblijven
			on roll_export close do
			(
				try(
					--messagebox "rollout will close"
					dir = "c:\3dsmax\MAXScript\JosBalcaen_Batch_Exporter"
					makeDir  dir
					OutputTextFile = dir + "/OutputPath.txt"
					deleteFile OutputTextFile
					createFile OutputTextFile
					filestreamvar = openFile OutputTextFile mode:"r+"
					OuputArr = ddlOutputpath.items
					aantal = OuputArr.count
					if aantal > 5 do aantal = 5
					for i = 1 to aantal do
					(
						--messagebox "writeline"
						format "%\n" OuputArr[i] to:filestreamvar
					)
					close filestreamvar
				)
				catch()
			)
	)
	rollout roll_multi "Export multiple max files"
	(
			local number_of_files = 0
			local ListOfMaxFiles = #()
			--label lbltitle "BATCH RENDER/EXPORT"
			button btnBrowseFile "Browse for files" width: 250
			multilistbox mlbMaxFiles
			label lbNumberOfFiles "No files selected"
			--button btnRender "Render all files" width: 250 height:50
			button btnExport "Export all files" width: 250 height:50 tooltip:"Exports all objects in scenes with the settings from above \nextra prefix : name of maxfile_"
			
			on mlbMaxFiles doubleClicked index do
			(
				itemArr = mlbMaxFiles.items
				ListOfImportFiles = deleteItem itemArr index
				mlbMaxFiles.items = ListOfImportFiles
			)
			on mlbMaxFiles selected index do
			(
				bitArr = mlbMaxFiles.selection  
				aantal = 0
				for i = 1 to bitArr.count do
				(
					if bitArr[i] ==true do aantal+=1
				)
				number_of_selected_files = aantal
				number_of_files = mlbMaxFiles.items.count
				lbNumberOfFiles.text = (number_of_selected_files as string) + "/" + number_of_files as string + " files selected"
			)
			
			on btnBrowseFile pressed do
			(
					
				theDialog = dotNetObject "System.Windows.Forms.OpenFileDialog" --create a OpenFileDialog 
				theDialog.title = "PLEASE Select One Or More Files" --set the title
				theDialog.Multiselect = true --allow multiple files to be selected
				theDialog.Filter = "MAX Files (*.max)|*.max"--|"All Files (*.*)|*.*" --specify the filter
				theDialog.FilterIndex = 1 --set the filter drop-down list to All Files
				result = theDialog.showDialog() --display the dialog, get result into variable
				result.ToString() --when closed, convert the result to string
				result.Equals result.OK --returns TRUE if OK was pressed, FALSE otherwise
				result.Equals result.Cancel --returns TRUE if Cancel was pressed, FALSE otherwise
				join ListOfMaxFiles theDialog.fileNames --the selected filenames will be returned as an array
				mlbMaxFiles.items = ListOfMaxFiles
				number_of_files = mlbMaxFiles.items.count
				lbNumberOfFiles.text = "All files"
			)
				
			on btnRender pressed do
			(
				--starttime = timeStamp()
				--theTimer = dotNetObject "System.Windows.Forms.Timer" --create a Timer
				--fn printTime = (print localTime) --define a MAXScript function to be called by the Timer.
				--dotnet.addEventHandler theTimer "tick" printTime --add ON TICK event hander to call the function
				--theTimer.interval = 1000 --set the tick interval to 1 second (1000 milliseconds)
				--theTimer.start() --start the Timer
				--timerstringstart = printTime()
				for i = 1 to (mlbMaxFiles.items.count) do
				(
					loadMaxFile (mlbMaxFiles.items[i] as string) quiet:true
					actionMan.executeAction 0 "50031"  -- Render: Render
				)
				--theTimer.stop()
				--printTime()
				timerstringend = printTime()
				total_time = theTimer.interval as string
				endtime = timeStamp()
				tijdsinterval = ((endtime - starttime) / 1000.0)
				tijdinuur = ((endtime - starttime) / 1000.0)/3600
				messagebox("succeeded, \n" + "start time : " + timerstringstart + "\n end time : " + timerstringend)-- + "\n total time : " + total_time)
			)
			on btnExport pressed do
			(
				--starttime = timeStamp()
				--theTimer = dotNetObject "System.Windows.Forms.Timer" --create a Timer
				--fn printTime = (print localTime) --define a MAXScript function to be called by the Timer.
				--dotnet.addEventHandler theTimer "tick" printTime --add ON TICK event hander to call the function
				--theTimer.interval = 1000 --set the tick interval to 1 second (1000 milliseconds)
				--theTimer.start() --start the Timer
				--timerstringstart = printTime()
				for i_files = 1 to (mlbMaxFiles.items.count) do
				(
			
					loadMaxFile (mlbMaxFiles.items[i_files] as string) quiet:true
					select $*
					SelectionList = getCurrentSelection()
					newselection = #()
					Extention = roll_export.ddlFormat.items[roll_export.ddlFormat.selection]
					OuputArr = roll_export.ddlOutputpath.items
					OutputPath = OuputArr[roll_export.ddlOutputpath.selection]
					
					--		if cbxResetObj.checked == true do ( SelectionList[i] = ResetObjects SelectionList i)
					--	)
					--	if ( cbxResetObj.checked == false ) do select SelectionList[i] -- need select the current obj to export seperatly
				
					filename = getFilenameFile (mlbMaxFiles.items[i_files] as string)
					if roll_export.cbxseparate.checked then
					(
						for i=1 to SelectionList.count do
						(
							
							if filename != undefined do
							(
								bitArr = mlbMaxFiles.selection  
								if bitArr[i_files] == true or lbNumberOfFiles.text == "All files" do
								(
									--if roll_export.cbxResetObj.checked == true do ResetObjects SelectionList i
									
									if roll_export.cbxChangeName.checked == true then
									(
										Filename = OutputPath + "\\" + filename + "_" + roll_export.edtPrefix.text + SelectionList[i].name + roll_export.edtSuffix.text + "." + Extention
									)
									else Filename = OutputPath+ "\\" + filename + "_" + SelectionList[i].name + "." + Extention
									
									select SelectionList[i]
									if roll_export.cbxExportOptions.checked then
									(
										exportfile Filename selectedOnly:TRUE
										roll_export.cbxExportOptions.checked = false
									)
									else
									(
										exportfile Filename #noPrompt selectedOnly:TRUE
										roll_export.cbxExportOptions.checked = false
									)

								)
							)
						)
					)
					else
					(
							if roll_export.cbxChangeName.checked == true then
							(
								Filename = roll_export.ddlOutputpath.text + "\\" + roll_export.edtPrefix.text + filename + roll_export.edtSuffix.text + "." + Extention
							)
							else Filename = roll_export.ddlOutputpath.text + "\\" + filename + "." + Extention
						
						exportfile Filename #noPrompt
						roll_export.cbxExportOptions.checked = false
					)
				)
				--theTimer.stop()
				--printTime()
				--timerstringend = printTime()
				--total_time = theTimer.interval as string
				--endtime = timeStamp()
				--tijdsinterval = ((endtime - starttime) / 1000.0)
				--tijdinuur = ((endtime - starttime) / 1000.0)/3600
				--messagebox("succeeded, \n" + "start time : " + timerstringstart + "\n end time : " + timerstringend)-- + "\n total time : " + total_time)
			)

	)
	rollout roll_import "Import"
	(
		local number_of_files = 0
		local ListOfImportFiles = #()

		button btnBrowseFile "Browse for files" width: 250 height:25
		multilistbox mlbImportFiles height:14
		label lbNumberOfFiles "No files selected"
		radiobuttons rbtImportType labels:#("import","merge","replace") \
		tooltip:#("Import non-native files into 3ds Max","Insert objects from external 3ds Max files into the current scene",\
			"Replaces objects in the current 3ds Max scene with objects from a exernal scene")
			checkbox chkImportOptions "Import options"
		button btnImport "Import all files" width: 250 height:50
		on mlbImportFiles doubleClicked index do
		(
			itemArr = mlbImportFiles.items
			ListOfImportFiles = deleteItem itemArr index
			mlbImportFiles.items = ListOfImportFiles
		)
		on mlbImportFiles selected index do
		(
			bitArr = mlbImportFiles.selection  
			aantal = 0
			for i = 1 to bitArr.count do
			(
				if bitArr[i] ==true do aantal+=1
			)
			number_of_selected_files = aantal
			number_of_files = mlbImportFiles.items.count
			lbNumberOfFiles.text = (number_of_selected_files as string) + "/" + number_of_files as string + " files selected"
		)
		on btnBrowseFile pressed do
			(
					
				theDialog = dotNetObject "System.Windows.Forms.OpenFileDialog" --create a OpenFileDialog 
				theDialog.title = "PLEASE Select One Or More Files" --set the title
				theDialog.Multiselect = true --allow multiple files to be selected
				theDialog.Filter = "OBJ Files (*.obj)|*.obj|All Files (*.*)|*.*" --specify the filter
				theDialog.FilterIndex = 2 --set the filter drop-down list to All Files
				result = theDialog.showDialog() --display the dialog, get result into variable
				result.ToString() --when closed, convert the result to string
				result.Equals result.OK --returns TRUE if OK was pressed, FALSE otherwise
				result.Equals result.Cancel --returns TRUE if Cancel was pressed, FALSE otherwise
				join ListOfImportFiles theDialog.fileNames --the selected filenames will be returned as an array
				mlbImportFiles.items = ListOfImportFiles
				lbNumberOfFiles.text = "All files"
			)
		on btnImport pressed do
		(
			--messagebox "will import"
			for i_files = 1 to (mlbImportFiles.items.count) do
			(
				item = mlbImportFiles.items[i_files]
				if item != undefined do
				(
					bitArr = mlbImportFiles.selection  
					if bitArr[i_files] == true or lbNumberOfFiles.text == "All files" do
					(
						filename = item as string
						case rbtImportType.state of (
							1: if(chkImportOptions.checked == true )then
							(
								if(importFile filename == false) do ()
								---chkImportOptions.checked = false
							)
							else
							(
								if(importFile filename #noPrompt == false) do ()
							)
							2: if(chkImportOptions.checked == true )then
							(
								if(mergeMAXFile filename #prompt == false)do ()
								chkImportOptions.checked = false
							)
							else
							(
								if(mergeMAXFile filename #renameMtlDups == false)do ()
							)
							3: if(chkImportOptions.checked == true )then
							(
								if(mergeMAXFile filename == false)do ()
								chkImportOptions.checked = false
							)
							else
							(
								if(mergeMAXFile filename #deleteOldDups #noPrompt== false)do ()
							)
						)
					)
				)

			)
		)
	)
	rollout roll_info "Info"
	(
		label lblmadeby "made by jos_balcaen@hotmail.com"
		label lblinfo "EXPORT SETTINGS : " pos:[5,25]
		label lblexportinfo "Reset geometry = pivot[0,0,0], scale[100,100,100] and rotate[0,0,0] without changing the object.  if checked it will be undone after export." pos:[50,40] width:200 height:70
		label lblexportinfo3 "Delete turbosmooth = delete turbosmooth-modifiers on selected objects. if checked it will be undone after export." pos:[50,95] width:200 height:70
		label lblexportinfo2 "Separate objects = each object in selection is separate exported." pos:[50,150] width:200 height:70
		label lblinfo2 "EXPORT MULTIPLE MAX FILES : " pos:[5,180]
		label lblmultiinfo  "Export multiple files = each file will be exported with the export settings above. everything will be selected" pos:[50,200] width:200 height:70
		label lblinfo3 "problems/comments/idea? mail me. " pos:[5,280]
		
		--if roll_multi.open == true do
		--messagebox "roll_multi open"
	)
	/*
	createDialog roll_Total 300 425

	--theNewFloater = newRolloutFloater "Grinning" 300 400
	--addRollout roll_export theNewFloater
	--addRollout roll_multi theNewFloater
	--addRollout roll_info theNewFloater
	AddSubRollout roll_Total.subroll_resetobj roll_export
	AddSubRollout roll_Total.subroll_resetobj roll_multi rolledUp:true
	AddSubRollout roll_Total.subroll_resetobj roll_import rolledUp:true
	AddSubRollout roll_Total.subroll_resetobj roll_info rolledUp:true
	
	--set position
		roll_Total.subroll_resetobj.pos = [5,5]
		roll_Total.subroll_resetobj.width = 287
		roll_Total.subroll_resetobj.height = 425
		--roll_export.subroll_resetobj
		--roll_export.width = 20
		roll_export.height = 325
		roll_multi.height = 300
		--roll_info.width = 20
		roll_info.height = 300/*
		*/
	Tabs_Rollouts = #(
	#("          Import          ",#(roll_import)),
		#("          Export          ",#(roll_export,roll_multi)),
			#("  Info  ",#(roll_info))
	)	
	rollout Tabs "Batch Export/Import by Jos"
	(
		dotNetControl dn_tabs "System.Windows.Forms.TabControl" height:20 width:420 align:#left
		subRollout theSubRollout width:280 height:370 align:#center

		on dn_tabs Selected itm do
		(
			if LastSubRollout != (itm.TabPageIndex+1) do --do not update if the same tab clicked twice
			(
				for subroll in Tabs_Rollouts[LastSubRollout][2] do
				removeSubRollout theSubRollout subroll
				for subroll in Tabs_Rollouts[LastSubRollout = itm.TabPageIndex+1][2] do	
				addSubRollout theSubRollout subroll
			) 
		)--end tabs clicked	

		on Tabs open do
		(
			for aTab in Tabs_Rollouts do
			(
			dn_tabs.TabPages.add aTab[1]
			)
			for subroll in Tabs_Rollouts[1][2] do 
			addSubRollout theSubRollout subroll		
		)
	)

	createDialog Tabs 280 400 style:#(#style_toolwindow,#style_sysmenu)
	/*********************************************************************************
	FUNCTIONS
	*********************************************************************************/
	function ResetObjects objectsArr index=
	(
		SelectionList = objectsArr --getCurrentSelection()
		newselection = #()
		if index == 0 then
		(
			--messagebox "reset geo of all obj"
			for i=1 to SelectionList.count do
			(
				--select SelectionList[i]
				TempName = SelectionList[i].name
				Tempcolor = SelectionList[i].wirecolor
		
				TempBox = Box()
				TempPoly = ConvertToPoly(TempBox)
				TempPoly.Attach SelectionList[i] TempPoly
				TempPoly.EditablePoly.SetSelection #Face #{1..6}
				TempPoly.EditablePoly.delete #Face
				TempPoly.name = TempName
				TempPoly.wirecolor = TempColor
				
				
				append newselection TempPoly
				--objectsArr[i] = TempPoly
			)
		)
		else
		(
			--messagebox "reset geo of single obj"
				obj = SelectionList[index]
				TempName = obj.name
				Tempcolor = obj.wirecolor
		
				TempBox = Box()
				TempPoly = ConvertToPoly(TempBox)
				TempPoly.Attach obj TempPoly
				TempPoly.EditablePoly.SetSelection #Face #{1..6}
				TempPoly.EditablePoly.delete #Face
				TempPoly.name = TempName
				TempPoly.wirecolor = TempColor
				
			--select TempPoly
				append newselection TempPoly
				--SelectionList[index] = TempPoly
			--return TempPoly
		)
		
		select newselection
		return newselection
	)
	function DeleteTurbo objectsArr index=
	(
		SelectionList = objectsArr --getCurrentSelection()
		if index == 0 then
		(
			for i = 1 to SelectionList.count do
			(
				for m in SelectionList[i].modifiers do
				(
					if classOf m==turboSmooth do deleteModifier SelectionList[i] m
				)
			)
		)
		else
		(
			for m in SelectionList[index].modifiers do
				(
					if classOf m==turboSmooth do deleteModifier SelectionList[index] m
				)
			select SelectionList[index]
		)
		
	)
)
